import { Map, List, Set, OrderedSet, Collection } from "immutable";
import { Type, NamedType, SeparatedNamedTypes } from "./Type";
import { GraphRewriteBuilder, TypeRef, TypeBuilder, StringTypeMapping } from "./TypeBuilder";
export declare class TypeGraph {
    private _typeBuilder?;
    private _topLevels?;
    private _types?;
    constructor(typeBuilder: TypeBuilder);
    private readonly isFrozen;
    freeze: (topLevels: Map<string, TypeRef>, types: List<Type>) => void;
    readonly topLevels: Map<string, Type>;
    typeAtIndex: (index: number) => Type;
    filterTypes<T extends Type>(predicate: (t: Type) => t is T, childrenOfType?: (t: Type) => Collection<any, Type>): OrderedSet<T>;
    allNamedTypes: (childrenOfType?: ((t: Type) => Collection<any, Type>) | undefined) => OrderedSet<NamedType>;
    allNamedTypesSeparated: (childrenOfType?: ((t: Type) => Collection<any, Type>) | undefined) => SeparatedNamedTypes;
    rewrite<T extends Type>(stringTypeMapping: StringTypeMapping, replacementGroups: T[][], replacer: (typesToReplace: Set<T>, builder: GraphRewriteBuilder<T>) => TypeRef): TypeGraph;
    allTypesUnordered: () => Set<Type>;
}
